/*
Copyright 2009-2011 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC  If not, see <http://www.gnu.org/licenses/>.
*/

#include "uart.h"
#include "Sleep.h"
#include "HamegProtocol.h"
#include "adc.h"

void pinsOutput();
void pinsTristate();

int main()
{
	uart_init();
	sei();
	sleep_10ms(10);
	Channel channel=tristate;
	//char forced;
	
	HMSetChannel(tristate);
	
	while(1)
	{
		switch(uart_getc())
		{
			case 0x30:  // test request
				uart_putc(0xF1);  // answer correct byte
				break;
			
			case 0x31:  // Read single screenshot, 2048 Bytes
				channel=uart_getc();
				HMSendScreenshot(channel);
				break;

			case 0x32: // Set channel selection, will be overwritten by a read command!
				channel=uart_getc();
				HMSetChannel(channel);
				break;
		}
	}

}

