/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC  If not, see <http://www.gnu.org/licenses/>.
*/

#include "adc.h"

void ADC_init()
{
  ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1);
}

uint16_t ADC_read(uint8_t channel)
{
  uint8_t i;
  uint16_t result = 0;
  
	ADMUX = channel; // Channel, use vcc as aref (REFS0 not set)
    //ADMUX |= (1<<REFS0);  // use vcc as aref
	ADCSRA |= (1<<ADSC);  // Dummyread
	while(ADCSRA & (1<<ADSC));
	
	for(i=0; i<3; i++)
	{
		ADCSRA |= (1<<ADSC);
		while(ADCSRA & (1<<ADSC));
			
		result += ADCW;
	}
	result /= 3;
	return result;
}

void ADC_stop()
{
  // ADC wieder deaktivieren
	ADCSRA &= ~(1<<ADEN);
}
