/*
Copyright 2009-2011 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "HamegInterface.h"

#include <QtGui/QMessageBox>

HamegInterface::HamegInterface()
{
	
}

HamegInterface::~HamegInterface()
{
	
}

int HamegInterface::openCom(QString port, unsigned int baud)
{
	return com.open(port.toStdString(), baud);
}

void HamegInterface::closeCom()
{
	com.close();
}

bool HamegInterface::checkConnection()
{
	com.clear();
	char command[]="0";
	char answer[5];
	com.write(command, 1);
	int readed=com.read(answer, 1, true, 1000);
	if(readed!=1)
	{
		return false;
	}
	if((unsigned char)answer[0]==0xf1)
	{
		return true;
	}
	else
	{
		return false;
	}
}

/*
 * getSingeShot gets a single graph from the scope
 * params:
 *   char* data: a pointer to a at least 2048 bytes large array
 *   char channel: '1' for channel 1, '2' for channel 2
 *   char forced: '0' for no force, '1' for forced request
 */
int HamegInterface::getSingleShot(char* data, char channel)
{
	com.clear();
	char command[]="10";
	command[1]=channel;
	com.write(command, 2);
	//int readed=read(data, 1);
	int readed=com.read(data, 1, true, 100);
	if(data[0]!=0x31)
		return 0;
	//readed=read(data, 2048, true, 2000);
	readed=com.read(data, 2048, true, 200);
	if(readed!=2048)
		return 0;
	else
		return 1;
}
